#ifndef X86_64_H
#define X86_64_H

/*******************************************************************************
Types:

R: RAX, RCX, RDX, RBX, R8, R9, R10, R11, R12, R13, R14, R15
V: BYTE(X), WORD(X)
Q: QWORD(X)
*******************************************************************************/

#define PUSH(RV) PUSH_ ## RV
#define POP(R) POP_ ## R
#define MOV(SRC,DST) MOV_ ## SRC ## _ ## DST
/* TODO: sub(R, RV) */

// #include "x86_64_opcodes.h"

#endif /* X86_64_H */
